using System;
using System.Collections.Generic;
using System.Reflection;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;

namespace platformerPeli;

/// @author Michal`O`
/// @version 23.10.2024
/// <summary>
/// 
/// </summary>
public class platformerPeli : PhysicsGame
{
    
    private const double nopeus = 300;
    private const double hyppyNopeus = 500;
    private PlatformCharacter pelaaja;
    private Image pelaajankuva = LoadImage("square.png");
    private Image background = LoadImage("Illustration27.png");
    private PhysicsObject alaSeina;


    /// <summary>
    /// private readonly Vector nopeusYlos = new Vector(0, 800);
    /// </summary>
    ///private readonly Vector nopeusAlas = new Vector(0, -800);
    ///private readonly Vector nopeusVasen = new Vector(-800, 0);
    ///private readonly Vector nopeusOikea = new Vector(800, 0);

    
    public override void Begin()
    {
        Level.Width = Screen.Width * 2;
        Level.Height = Screen.Height * 1.5;
        SetWindowSize(1280, 720, false);
        Level.Background.Image = background;
        Level.Background.FitToLevel();
        LuoKentta();
        Camera.Follow(pelaaja);
        Camera.ZoomToLevel();
        
        
        
        ///PhysicsObject pelaaja = new PhysicsObject(2 * 20.0, 2 * 20.0, Shape.Rectangle);
        ///pelaaja.Y = Level.Bottom + 200.0;
        ///Add(pelaaja);

        Gravity = new Vector(0.0, -1000);
        pelaaja = new PlatformCharacter(40, 40);
        Vector pelaajanPaikka = new Vector(0, 200);
        LisaaPelaaja(pelaajanPaikka, 40, 80, pelaaja, pelaajankuva);
        LisaaNappaimet();
        
        ///PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        ///Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }

    private void LuoKentta()
    {
        alaSeina = Level.CreateBottomBorder();
        alaSeina.Restitution = 0.0;
    }

    private void LisaaPelaaja(Vector paikka, double leveys, double korkeus, PlatformCharacter pelaaja, Image kuva)
    {
        pelaaja.Position = paikka;
        pelaaja.Image = kuva;
        pelaaja.Restitution = 0.0;
        Add(pelaaja);
    }


    private void LisaaNappaimet()
    {
        Keyboard.Listen(Key.W, ButtonState.Pressed, Hyppaa, "Pelaaja 1: Liikuta mailaa ylös", pelaaja, hyppyNopeus);
        ///Keyboard.Listen(Key.W, ButtonState.Released, AsetaNopeus,null, pelaaja, Vector.Zero);
        ///Keyboard.Listen(Key.S, ButtonState.Down, AsetaNopeus, "Pelaaja 1: Liikuta mailaa alas", pelaaja, nopeusAlas);
        ///Keyboard.Listen(Key.S, ButtonState.Released, AsetaNopeus,null, pelaaja, Vector.Zero);
        Keyboard.Listen(Key.A, ButtonState.Down, Liikuta, "Pelaaja 1: Liikuta mailaa alas", pelaaja, -nopeus);
        ///Keyboard.Listen(Key.A, ButtonState.Released, AsetaNopeus,null, pelaaja, Vector.Zero);
        Keyboard.Listen(Key.D, ButtonState.Down, Liikuta, "Pelaaja 1: Liikuta mailaa alas", pelaaja, nopeus);
        ///Keyboard.Listen(Key.D, ButtonState.Released, AsetaNopeus,null, pelaaja, Vector.Zero);
        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }


    ///    private void AsetaNopeus(PhysicsObject pelaaja, Vector nopeus)
    ///    {
    ///
    ///        if ((nopeus.Y < 0 ) && (pelaaja.Bottom < Level.Bottom))
    ///        {
    ///            pelaaja.Velocity = Vector.Zero;
    ///            return;
    ///        }
    ///        if ((nopeus.Y > 0 ) && (pelaaja.Top > Level.Top))
    ///        {
    ///            pelaaja.Velocity = Vector.Zero;
    ///            return;
    ///        }
    ///        
    ///        pelaaja.Velocity = nopeus;
    ///    }
    ///    

    private void Liikuta(PlatformCharacter pelaaja, double nopeus)
    {
        pelaaja.Walk(nopeus);
    }

    private void Hyppaa(PlatformCharacter pelaaja, double nopeus)
    {
        pelaaja.Jump(nopeus);
    }

}